Attribute VB_Name = "modMain"
Option Explicit

Type Vector
  x As Single
  y As Single
  z As Single
End Type

Public Running As Boolean
Public Keyb(255) As Boolean
Public Ro(7) As Vector
Public DTime As Single
Public Star As New Star
Public Oval As New Oval
Public FPS As Long
Public Inverse As Single

Dim SpBuf As New SR2D_Sprite
Dim SpBack As New SR2D_Sprite
Dim SpMnu1 As New SR2D_Sprite
Dim SpMnu2 As New SR2D_Sprite
Dim DirX As Single, DirY As Single
Dim RotSpX As Single, RotSpY As Single
Dim tDX As Single, tDY As Single
Dim tDPX As Single, tDPY As Single

Dim MaxDX As Single, MaxDY As Single
Dim MaxX As Single, MaxY As Single
Dim MaxSp As Single

Public Sub Main()
  frmMain.Show
  If Command$ <> "" Then Inverse = -1 Else Inverse = 1
  InitAll
  Do
    MainLoop
    MainMnu
  Loop While Running
  TerminateAll
  Unload frmMain
End Sub

Private Sub MainMnu()
Dim t As Single
  t = Timer - 65
  frmMain.SpriteCreateText SpMnu1, "Press 1 to 5 to Select Game Level"
  Running = True
  Do While Running
    DoEvents
    FPS = FPS + 1
    If Timer - t > 64 Then
      t = Timer
      DShowStop
      RunAudio App.Path & "\mnu.mid", 1
    End If
    If Keyb(vbKeyEscape) Then Keyb(vbKeyEscape) = False: Running = False
    If Keyb(vbKey1) Then
      MaxDX = 0.3
      MaxDY = 0
      MaxX = 0.1
      MaxY = 0
      MaxSp = 12
      Exit Do
    End If
    If Keyb(vbKey2) Then
      MaxDX = 0
      MaxDY = 0.3
      MaxX = 0
      MaxY = 0.1
      MaxSp = 14
      Exit Do
    End If
    If Keyb(vbKey3) Then
      MaxDX = 0.3
      MaxDY = 0.3
      MaxX = 0.1
      MaxY = 0.1
      MaxSp = 16
      Exit Do
    End If
    If Keyb(vbKey4) Then
      MaxDX = 0.4
      MaxDY = 0.4
      MaxX = 0.2
      MaxY = 0.2
      MaxSp = 16
      Exit Do
    End If
    If Keyb(vbKey5) Then
      MaxDX = 1
      MaxDY = 1
      MaxX = 0.5
      MaxY = 0.5
      MaxSp = 24
      Exit Do
    End If
    RenderMnu
  Loop
  DShowStop
End Sub

Private Sub RenderMnu()
  SpBuf.BlockDraw SpBack, 0, 0, SpBuf.Width, SpBuf.Height, Sin(QTime * 0.4) * 300, Cos(QTime * 0.3) * 300
  SpBuf.Draw SpMnu1, 320 - SpMnu1.Width \ 2, 120, OpAdd
  SpBuf.Draw SpMnu2, 320 - SpMnu2.Width \ 2, 290, OpAdd
  SpBuf.PaintToHDC frmMain.hDC
End Sub

Private Sub MainLoop()
Dim t1 As Single, t2 As Single
Dim t As Single
Dim n As Long
  For n = 0 To 7
    Ro(n).x = 0
    Ro(n).y = 0
    Ro(n).z = n * 4 + 1
  Next n
  RotSpX = 0
  RotSpY = 0
  DirX = 0
  DirY = 0
  tDX = 0
  tDY = 0
  tDPX = 0
  tDPY = 0

  t = Timer
  RunAudio App.Path & "\game.mid", 1
  t2 = QTime
  Do While Running
    DoEvents
    t1 = QTime
    DTime = t1 - t2
    t2 = t1
    Driv
    Tick
    Render
    FPS = FPS + 1
    If Timer - t > 92 Then
      Running = False
    End If
  Loop
  DShowStop
End Sub

Private Sub Render()
Dim n As Long
  SpBuf.BlockDraw SpBack, 0, 0, SpBuf.Width, SpBuf.Height, DirX * 18000, DirY * 18000
  For n = 0 To 7
    Oval.DrawTo SpBuf, Ro(n).x, Ro(n).y, Ro(n).z
  Next n
  SpBuf.PaintToHDC frmMain.hDC
End Sub

Public Sub Tick()
Dim n As Long
  For n = 0 To 7
    Ro(n).z = Ro(n).z - DTime * MaxSp
    If Ro(n).z < 1 Then
      If (Ro(n).x * Ro(n).x + Ro(n).y * Ro(n).y) * Ro(n).z * Ro(n).z > 1 Then
        Running = False
      End If
      tDX = tDX + (Rnd - 0.5) * MaxDX
      tDY = tDY + (Rnd - 0.5) * MaxDY
      If tDX > 0.1 Then tDX = MaxX
      If tDX < -0.1 Then tDX = -MaxX
      If tDY > 0.1 Then tDY = MaxY
      If tDY < -0.1 Then tDY = -MaxY
      tDPX = tDPX + tDX
      tDPY = tDPY + tDY
      If tDPX > 0.1 Then tDPX = 0.1
      If tDPX < -0.1 Then tDPX = -0.1
      If tDPY > 0.1 Then tDPY = 0.1
      If tDPY < -0.1 Then tDPY = -0.1
      
      Ro(n).z = Ro(n).z + 32
      Ro(n).x = Ro((n + 7) And 7).x + tDPX
      Ro(n).y = Ro((n + 7) And 7).y + tDPY
    End If
  Next n
End Sub

Public Sub Driv()
Dim Sens As Single
Dim n As Long
  Sens = DTime * 0.1
  If Keyb(vbKeyEscape) Then Keyb(vbKeyEscape) = False: Running = False
  If Keyb(vbKeyLeft) Then
    RotSpX = RotSpX * (1 - Sens) + Sens
  ElseIf Keyb(vbKeyRight) Then
    RotSpX = RotSpX * (1 - Sens) - Sens
  End If
  If Keyb(vbKeyUp) Then
    RotSpY = RotSpY * (1 - Sens) - Sens * Inverse
  ElseIf Keyb(vbKeyDown) Then
    RotSpY = RotSpY * (1 - Sens) + Sens * Inverse
  End If
  For n = 0 To 7
    Ro(n).x = Ro(n).x + RotSpX * DTime * Ro(n).z
    Ro(n).y = Ro(n).y + RotSpY * DTime * Ro(n).z
  Next n
  DirX = DirX + RotSpX * DTime
  DirY = DirY + RotSpY * DTime
End Sub

Private Sub CreateSprites()
  frmMain.SpriteLoadFromFile SpBack, "m20.jpg"
  frmMain.SpriteCreateText SpMnu2, "Press Esc to Exit"
End Sub

Private Sub InitAll()
  Randomize Timer
  SpBuf.Init 640, 480
  SpBack.Init 640, 640
  QFreq_Init
  CreateSprites
End Sub

Private Sub TerminateAll()
  Set SpBuf = Nothing
  Set SpBack = Nothing
  Set Oval = Nothing
  Set Star = Nothing
End Sub
